import copy
#from Bio.PhyloNou.PhyloNetwork import PhyloNetwork

def push_and_hang(net,u,newtaxa):
    parents=net.predecessors(u)
    newnet=copy.deepcopy(net)
    w=newnet.getlabel()
    for parent in parents:
        newnet.delete_edge(parent,u)
        newnet.add_edge(parent,w)
    newnet.add_edge(w,u)
    newnet.add_edge(w,newtaxa)
    newnet._labels[newtaxa]=newtaxa
    newnet.forget()
    return newnet

def hold_and_hang(net,u,newtaxa):
    newnet=copy.deepcopy(net)
    newnet.add_edge(u,newtaxa)
    newnet._labels[newtaxa]=newtaxa
    newnet.forget()
    return newnet

def push_and_label(net,u,newtaxa):
    parents=net.predecessors(u)
    newnet=copy.deepcopy(net)
    for parent in parents:
        newnet.delete_edge(parent,u)
        newnet.add_edge(parent,newtaxa)
    newnet.add_edge(newtaxa,u)
    newnet._labels[newtaxa]=newtaxa
    newnet.forget()
    return newnet

def hold_and_label(net,u,newtaxa):
    if net.is_labelled(u):
        return
    newnet=copy.deepcopy(net)
    newnet._labels[u]=newtaxa
    newnet.forget()
    return newnet

def hang_to_parent(net,u,newtaxa):
    paru=net.predecessors(u)
    if len(paru)!=1:
        return
    paru=paru[0]
    if net.is_hybrid_node(paru):
        return
    newnet=copy.deepcopy(net)
    newnet.add_edge(paru,newtaxa)
    newnet._labels[newtaxa]=newtaxa
    newnet.forget()

def pure_ancestors(net,u):
    anc=[u]
    current=u
    while len(net.predecessors(current))==1:
        current=net.predecessors(current)[0]
        anc.append(current)
    return anc

def terminal_edge_atack(net,u,v):
    l1=pure_ancestors(net,u)
    l2=pure_ancestors(net,v)
    common = set(l1) & set(l2)
    if not common:
        return
    newnet=copy.deepcopy(net)
    paru=newnet.predecessors(u)[0]
    parv=newnet.predecessors(v)[0]
    newnet.delete_edge(paru,u)
    newnet.delete_edge(parv,v)
    wu=newnet.getlabel()
    wv=newnet.getlabel()
    newnet.add_edge(paru,wu)
    newnet.add_edge(parv,wv)
    newnet.add_edge(wu,u)
    newnet.add_edge(wv,v)
    newnet.add_edge(wu,wv)
    newnet.forget()
    print newnet.eNewick()
    print u,v
    print l1,l2
    return newnet
